#include <sstream>
#include <iostream>

#include "soapH.h"

// gestion du namespace. Habituellement, cette sctructure est dclare dans un fichier
// spar (mon_cs.nsmap), car il est identaique pour le client et le serveur. Moi je
// l'ai mis directement ici pour simplifier mon tuto.
SOAP_NMAC struct Namespace namespaces[] =
{
	{"SOAP-ENV", "http://schemas.xmlsoap.org/soap/envelope/", "http://www.w3.org/*/soap-envelope", NULL},
	{"SOAP-ENC", "http://schemas.xmlsoap.org/soap/encoding/", "http://www.w3.org/*/soap-encoding", NULL},
	{"xsi", "http://www.w3.org/2001/XMLSchema-instance", "http://www.w3.org/*/XMLSchema-instance", NULL},
	{"xsd", "http://www.w3.org/2001/XMLSchema", "http://www.w3.org/*/XMLSchema", NULL},
	{"ns", "urn:mon_cs", NULL, NULL},
	{NULL, NULL, NULL, NULL}
};

// adresse du serveur et port 
const char server[] = "http://127.0.0.1:8080";

int main(int argc, char **argv)
{ 
	if (argc < 3)
	{ 
		std::cout << "vous devez entrer 2 arguments" << std::endl << "appuyez sur une touche pour quitter";
		std::cin.get();
		return 0;
	}

	struct soap soap; // structure soap
	int a, b, result; // variables
	
	// initialisation de soap
	soap_init(&soap);

	// transcription des variables lues dans la commande en entiers
	std::istringstream issa( argv[1] );
	issa >> a;
	std::istringstream issb( argv[2] );
	issb >> b;
  
	// envoi de la requte au serveur
	soap_call_op1( &soap, server, "", a, b, &result );

	if (soap.error)
		std::cout << "error" << std::endl;
	else
		std::cout << "resultat = " << result << std::endl;

	std::cout << "appuyez sur une touche pour quitter";
	std::cin.get();
	return 0;
}
