#include <iostream>

#include "soapH.h"

// gestion du namespace. Habituellement, cette sctructure est dclare dans un fichier
// spar (mon_cs.nsmap), car il est identaique pour le client et le serveur. Moi je
// l'ai mis directement ici pour simplifier mon tuto.
SOAP_NMAC struct Namespace namespaces[] =
{
	{"SOAP-ENV", "http://schemas.xmlsoap.org/soap/envelope/", "http://www.w3.org/*/soap-envelope", NULL},
	{"SOAP-ENC", "http://schemas.xmlsoap.org/soap/encoding/", "http://www.w3.org/*/soap-encoding", NULL},
	{"xsi", "http://www.w3.org/2001/XMLSchema-instance", "http://www.w3.org/*/XMLSchema-instance", NULL},
	{"xsd", "http://www.w3.org/2001/XMLSchema", "http://www.w3.org/*/XMLSchema", NULL},
	{"ns", "urn:mon_cs", NULL, NULL},
	{NULL, NULL, NULL, NULL}
};

int main( int argc, char **argv )
{ 
	SOAP_SOCKET m, s; /* master and slave sockets */
	struct soap soap; /* structure soap */

	soap_init(&soap); // initialisation du serveur
	
	m = soap_bind( &soap, NULL, 8080, 100); // liaison avec le master socket 
	if ( !soap_valid_socket( m ) )
	{ 
		std::cout << "erreur de connection" << std::endl << "appuyez sur une touche pour quitter";
		std::cin.get();
		return 1;
	}

	// boucle principale
	std::cout << "connection russie: master socket = " << m << std::endl;
	for ( ; ; )
	{
		s = soap_accept( &soap );
		std::cout << "connection au client ok: slave socket = " << s << std::endl;
		if ( !soap_valid_socket( s ) )
		{ 
			std::cout << "erreur: problme de socket" << std::endl << "appuyez sur une touche pour quitter";
			return 1;
		} 
		soap_serve( &soap );
		soap_end( &soap );
	}

	return 0;
} 

// dfinition des oprations (dclares dans mon_cs.h)
// ici je n'en ai qu'une: op1
int op1( struct soap *soap, int a, int b, int * r )
{ 
	std::cout << "op1 appel avec: a=" << a << ", b=" << b << std::endl;
	*r = 2 * a + b;
	return SOAP_OK;
} 